# Flutter SMS Inbox

[![pub package](https://img.shields.io/pub/v/flutter_sms_inbox.svg)](https://pub.dev/packages/flutter_sms_inbox)
[![pub points](https://img.shields.io/pub/points/flutter_sms_inbox?color=2E8B57&label=pub%20points)](https://pub.dev/packages/flutter_sms_inbox/score)

Flutter android SMS inbox library based on [Flutter SMS](https://github.com/babariviere/flutter_sms).

### Dependencies

This package in turn uses the permission handler package for permission handling, [Permission Handler](https://pub.dev/packages/permission_handler).

You need to add it to your project:

```
dependencies:
  permission_handler: ^10.2.0
```

## Querying SMS messages

Add the import statement for sms and create an instance of the SmsQuery class:

```
import 'package:flutter_sms_inbox/flutter_sms_inbox.dart';

void main() {
  SmsQuery query = SmsQuery();
}
```

## Getting all SMS messages

`List<SmsMessage> messages = await query.getAllSms;`

## Filtering SMS messages
The method `querySms` from the `SmsQuery` class returns a list of sms depending of the supplied parameters. For example, for querying all the sms messages sent and received write the followed code:

```
await query.querySms(
    kinds: [SmsQueryKind.inbox, SmsQueryKind.sent],
);
```
You can also query all the sms messages sent and received from a specific contact:

```
await query.querySms(
    address: getContactAddress()
);
```
